import { transform, isEmpty, isObject, isEqual } from 'lodash';

export function changes(obj, base, preserve) {
  return transform(obj, function(result, value, key) {
    const _preserve = Array.isArray(obj) ? { id: true, size: true } : null;
    if (!isEqual(value, base[key])) {
      result[key] = (isObject(value) && isObject(base[key])) ? changes(value, base[key], _preserve) : value;
      if (preserve) {
        Object.keys(preserve).forEach(preserveKey => {
          if (base[preserveKey]) {
            result[preserveKey] = base[preserveKey];
          }
        });
      }
    }
  });
}
