import Storage from 'dom-storage';
import fs from 'fs';

const localStorage = new Storage(null, { strict: true });
import usersIndex from '../assets/test/users/index.json';
import mainIndex from '../assets/test/main/index.json';
import mainDetail from '../assets/test/main/detail1501765968589.json';
import mainList from '../assets/test/main/list1501765968589.json';
import blankIndex from '../assets/test/blank/index.json';
const testData = {
  '/users/index.json': usersIndex,
  '/main/index.json': mainIndex,
  '/main/list1501765968589.json': mainList,
  '/main/detail1501765968589.json': mainDetail,
  '/blank/index.json': blankIndex,
  'test.json': { test: true, date: 1 },
};
function fetch(url) {
  console.log('! fetch for test >>', url);
  const [ path ] = url.split('?');
  return Promise.resolve({
    text() {
      return Promise.resolve(JSON.stringify(testData[path]));
    },
    json() {
      return new Promise((res, rej) => {
        if (testData.hasOwnProperty(path)) {
          res(testData[path]);
        } else {
          rej('404');
        }
      });
    }
  });
}

global._test_body_ = fs.readFileSync('assets/test/config.json');
global.localStorage = localStorage;
global.fetch = fetch;
global.window = {
  fetch,
  localStorage,
  JSON
};
